;;;; c:\.xemacs\init.el
;;; for xemacs under win32 together with auctex and miktex
;;; this sample-file is made for beginners, please read carefully
;;; the comments, it is for LaTeX-users.
;;; It is tested vers. 1.0.0 under XEMACS 21.4.13, OS: WIN32(WINXP)
;;; And vers. 1.0.3 under XEMACS 21.4.19, OS: WIN32(WINXP)
;;; auctex vers. 1.53 (xemacs-auctex version 1.42) and higher
;;; please check with versions you have!
;;; for tips for your local xemacs see also the actual file 
;;; sample.init.el of your xemacs distribution. 
;;; Ulm, Germany, Nov. 2004, stefan@pofahl.de 
;;; What you need:
;;  - acrord32.exe (Acrobat reader), please check the program path
;;  - ghostview and ghostscript, please check the program path
;;  - gnuclient (includet in gnuserv-2.1p1.zip), for inverse search,
;;    copy gnuclientw.exe, gnudoit.exe, gnuserv.exe in the home dir of 
;;    "xemacs.exe", e.g.: "C:\Program Files\XEmacs\XEmacs-21.4.13\i586-pc-win32\"
;;    exchange the file "gnuserv.el" from this package with file that is shipped
;;    with your xemacs installation and byte compile it to "gnuserv.elc"
;;  - lacheck.exe (last destination was: ftp://ftp.dante.de/tex-archive/support/lacheck/nt)
;;  - lacheckw32.exe (lacheck v. 1.24 includet in the file `lachckpc.zip')
;;    copy this in the bin-directory of miktex 
;;    (I have found it at http://www.ctan.org/tex-archive/support/lacheck/)
;;  - to make use of the option -Ppdf of the converter dvips it is good to have
;;    the necessary fonts, on miktex installations you can call the documentation
;;    of dvips on the command line by the command `mthelp --view dvips'.
;;    To install the necessary fonts look if you have the following packages installed:
;;    >>  cm-super, qxcm, cmpica, cmextra, ttcmex  <<
;;    and perhaps: >> psnfss, psnfssx, tex-ps <<
;;  - tex4ht, please download the latest version!!!
;;  - miktex package "latex2e-help-texinfo.cab" and inside this package
;;    you have to extract "latex2e-help-texinfo-src.cab" an copy the files 
;;    to a propper xemacs directory (for further information read instructions below)
;;  - I had problems with dvipdfmx.exe, I had to find the file `dvipdfmx.def'
;;    (The homepage of the project is: `http://project.ktug.or.kr/dvipdfmx/'
;;    and the file is includet in the file: `dvipdfmx-20050831.tar.gz'
;;  - put miktex and xemacs in your invoroment variable "path",
;;    e.g.: path= C:\Programme\Miktex\texmf\miktex\bin;%SystemRoot%\system32;%SystemRoot%;c:\bin\bat;C:\Program Files\XEmacs\XEmacs-21.4.13\i586-pc-win32;
;;  - Notice for WIN-XP users:
;;    Dependend on your installation, it can happen, that important configuration files 
;;    are present on the root directory: "c:\", in this case and if you want to work as normal user, you have to set the rights correctly,
;;    under WIN-XP you can do the job as Administrator with the command cacls:
;;    e.g. cacls "C:\.xemacs\*.el" /t /e /g ZSW119\spofahl:w
;;    e.g. cacls "C:\.recent-files.el" /t /e /g ZSW119\spofahl:w
;;    Important also:
;;    cacls "C:\WINDOWS\system32\wbem\Repository\FS" /t /e /g ZSW119\spofahl:f
;;    cacls "C:\WINDOWS\Prefetch" /t /e /g ZSW119\spofahl:f
;;  - mount.exe (part of cygwin, maybe necessary for ispell (depends on the version that is installed on your machine),
;;    it may expects a path like / instead of c:\)
;;  - some batchfiles, such as: 
;;    "C:\\Programme\\MiKTeX\ 2.8\\miktex\\bin\\latex2dvi2ps2pdf.bat"
;;    "C:\\Programme\\MiKTeX\ 2.8\\miktex\\bin\\dvipdfmx.bat"
;;    "C:\\Programme\\MiKTeX\ 2.8\\miktex\\bin\\dvipdfm.bat"
;;    "C:\\Programme\\MiKTeX\ 2.8\\miktex\\bin\\openpdf.bat"
;;    "C:\\Programme\\MiKTeX\ 2.8\\miktex\\bin\\texifypdf.bat"
;;    (please check the program pathes inside the batch-files)
;;  - grep.exe (part of unix utils / gnu utils for win32 "UnxUtils.zip" and "UnxUpdates.zip"
;;    necessary for grep-command under ref-tex, put this binary in the folder of xemacs.exe,
;;    for me this feature is one of the most interesting of ref-tex, if you work with subfiles.
;;    (the grep.exe-version from the "UnxUtils.zip" should not need the "cygwin1.dll" 
;;  - "cygwin1.dll" if you have the cygwin-version of grep, you need also the corresponding
;;    cygwin1.dll
;;    copy it to a central place (e.g. "C:\WINDOWS\system32")
;;  - gnuplot-mode.el, written by Bruce Ravel <ravel@phys.washington.edu>
;;    (last address was: http://cars9.uchicago.edu/~ravel/software/gnuplot-mode.html )
;;    for propper installation read includet readme file
;;  - octave-mod.el, octave-inf.el octave-hlp.el (I don't know where you get the latest, I got a version at:
;;    http://www.koders.com/)
;;    check also repository: http://velveeta.che.wisc.edu/cgi-bin/cvsweb.cgi/octave/emacs/
;;    Notice: Packages for emacs may not work for XEmacs!!! - Perhaps you find somewhere a package for XEmacs.
;;  - kill.exe, only if you do not want to use the `pdfopen.exe' and `pdfclose.exe',
;;    so if you have MikTex 2.5 or higher you don't need it anymore :-)
;;    (Terminator of processes, e.g. part of MS windows resource kit)
;;    (necessary to kill arcord32.exe)
;;  - SumatraPDF-TeX.exe (http://william.famille-blum.org/software/sumatra/SumatraPDF-TeX.exe)
;;    SumatraPDF-TeX.exe (famille-blum) and SumatraPDF.exe (original) supports inverse search :-)
;;    Configuration of Sumatra: "C:\Programme\XEmacs\XEmacs-21.4.22\i586-pc-win32\gnuclientw.exe" -F +%l "%f"
;;  - ddeclient.exe (http://ftp.gnu.org/old-gnu/emacs/windows/docs/ntemacs/contrib/ddeclient.zip)
;;    (Needed for Inverse Search together with Sumatra)
;;  - sumatra-forward.el (http://william.famille-blum.org/software/sumatra/sumatra-forward.el)
;;    (Needed for Inverse Search together with Sumatra)
;;;;   After installation: --------------------------------------------------
;;    To be shure that all *.el files in a directory are byte compiled try the following:
;;    M-x byte-recompile-directory DIRECTORY
;;    e.g. M-x byte-recompile-directory C:\Programme\XEmacs\
;;; ------- Changes --------------------------------------------------------
;;    Vers.1.0.0 Nov.2004 Start
;;    Vers.1.0.1 Sep.2004 Tip by Ralf Angeli: Use `TeX-command-menu' to call the functions from `TeX-Command-list'
;;    Vers.1.0.2 Aug.2006 Implementation of octave mode, minor changes 
;;    Vers.1.0.3 Aug.2006 
;;               - change path from c:\\Program Files\\...\XEmacs-21.4.13\\... 
;;                               to c:\\Programme\\...\\XEmacs-21.4.19\\...
;;               - changes related to the new miktex 2.5, especialy the new texify.exe
;;                               MiKTeX Compiler Driver 2.5.2400 (MiKTeX 2.5)
;;               - add menu entry for pdfopen.exe 
;;               - changed batch files
;;               - menu entry for the "new" lacheckw32.exe
;;               - menu entry for the htlatex.exe
;;               - add new extension-patterns to the clean order 
;;    Vers.1.0.4 Jan.2009
;;               - work on entries for ispell usage
;;    Vers.1.0.5 Jan.2009
;;               - work on the entries for Gnuplot-Mode
;;    Vers.1.0.6 Aug.2009
;;               - work on library `whitespace'
;;    Vers.1.0.7 Jan.2010
;;               - switch from MiKTeX 2.7 --> 2.8
;;               - add list `LaTeX-fill-break-at-separators'
;;               - add variable `TeX-DVI-via-PDFTeX'
;;               - correct value of `n'
;;               - add keys to gnuplot-mode-map
;;   Vers.1.0.8 Mai 2010
;;               - Key Stroke C-F5 fixed (works now) 
;;   Vers.1.0.9 Jun 2010
;;               - Add Sumatra as PDF-Viewer
;;   ------------------------------------------------------------------------------
;;   Remark (14. Jun. 2010): 
;;   My miktex: texify-command does not work, so I use the normal pdflatex-command
;;   ------------------------------------------------------------------------------
;;
;;;; To do (to make this init.el better) -----------------------------------
;;  - configure octave mode in a way, that starting octave processes from within XEmacs on WIN-XP is possible
;;  - configure latex help properly
;;;; Tip:
;;; A lot of packeges have documentations hidden in the *.texi-files, you can
;;; translate them into a PDF-File via texify.exe tool from miktex distribution (LaTeX-Distribution)
;;; texify -V -c --pdf foo.texi
;;; ------------------------------------------------------------------------
;;;;;  ------- Start ------------------------------------------------------ ;;;;;
;;;; base configuration of xemacs under win32:
;; debug on error:
(setq debug-on-error t
      stack-trace-on-error t) ;; give error message, if there is an error
;; add to load path
(setq load-path (cons "C:\\Programme\\XEmacs\\xemacs-packages\\lisp\\" load-path))
;; I don't know how to load also the subdirectories of "\\lisp\\" so I only load one 
;; DIR at a time, I tried two suggestions from the net, but both were not working
;; with my xemacs on WIN32. MULE stands for (for "MULti-lingual Enhancement to GNU Emacs")
;(add-to-list 'load-path 
;      (expand-file-name "C:\\Programme\\XEmacs\\XEmacs-21.4.22\\lisp\\mule\\"))
;; location of ltx-help 
;; add  directory `latex2e-help-texinfo' to the variable `load-path':
(add-to-list 'load-path "C:\\Programme\\XEmacs\\xemacs-packages\\lisp\\latex2e-help-texinfo\\")

;; --------  end define search-path  ------------------
;;; load libraries:
;;; --------- WIN32 Preparations -------------
(load "win32-native") ;; I don't know if it makes sense, but it sounds god ;-)
;;; Enable System catching key stroke "M-tab" on emacs (not xemacs) 
;;; COMMENT THIS OUT IF YOU WANT Windows, NOT Emacs(not xemacs), to use M-TAB.
;(when (fboundp 'w32-register-hot-key) (w32-register-hot-key [M-tab]))

;; -------  FONT LOCK   --------------
;; Load it now so we can modify the fonts
(require 'font-lock)
;; Maximum colour but minimum chatter
(setq-default font-lock-maximum-decoration t
	      font-lock-verbose nil)
;; Of all the modes, font-lock *least* needs a modeline
;; indicator. If the buffer is colourful, font-lock is on.
;; The only thing you lose is the ability to toggle it.
;; origin: http://xemacs.seanm.ca/cvs/init/init.el
(let ((el (assq 'font-lock-mode minor-mode-alist)))
  (if el (setcdr el '(""))))
;;; ----- position and size of the Window -----------
(setq default-frame-plist      '((top . 000) (left . 000)
    (width . 150) (height . 44)  (cursor-color . "red")
    (background-color . "wheat")
    (vertical-scroll-bars . right)
   ;fonts found on the mailing list, uncomment one at your convenience
   ;(font . "-*-Courier-normal-r-*-*-13-97-*-*-c-*-*-ansi-")
   ;(font . "-*-Terminal-normal-r-*-*-8-60-*-*-c-*-*-oem-")
   ;(font . "-*-Terminal-normal-r-*-*-12-72-*-*-c-80-*-oem-")
   ;(font . "-*-Terminal-normal-r-*-*-8-60-*-*-c-*-*-oem-")
   ;(font . "-*-Terminal-normal-r-*-*-19-142-*-*-c-*-*-oem-")
    )
    ) 
;;;   Add the following to display the column number
(column-number-mode 1)
;;;   Add the following to display the line number:
(line-number-mode 1)
;;;   Stop down-arrow from adding empty lines to the bottom of the buffers?
(setq next-line-add-newlines nil)
;; Use C-h v or `Help->Commands, Variables, Keys->Describe Variable...'
;; to find out what these variables mean.
(setq
 find-file-compare-truenames t
 minibuffer-max-depth nil
 )

;;;; whitespace --------------------------------------------------------------------------
;;;; make use of library "whitespace" (it makes visible diffenrent type of "whitespace")
;;;; see: http://www.emacswiki.org/emacs/WhiteSpace
   (require 'whitespace)
;; or alternatively to (require 'whitespace) you can use (autoload ...):
;  (autoload 'global-whitespace-mode           "whitespace" "Toggle whitespace visualization."        t)
;  (autoload 'global-whitespace-toggle-options "whitespace" "Toggle local `whitespace-mode' options." t)

;;; add `gnuplot-mode' to the list `whitespace-modes' 
;; If you want to add a mode (e.g. 'my-mode' to the list whitespace-modes, add:
;; (setq whitespace-modes (cons 'my-other-mode whitespace-modes))
;; If you want to add two modes 'my-mode' + 'my-other-mode' add the following:
;; (setq whitespace-modes (cons 'my-mode (cons 'my-other-mode
;;					    whitespace-modes))
;  (setq whitespace-modes (cons 'gnuplot-mode whitespace-modes))
;; Or redefine the variable `whitespace-modes'
  (setq whitespace-modes '(gnuplot-mode))

;; (push ...) found in: http://calypso.tux.org/pipermail/xemacs-patches/2008-March/001493.html (Didier Verna)
   (push 'text-mode whitespace-modes)
;;   (push 'gnuplot-mode whitespace-modes)
;;; add `whitespace-write-file-hook' to the `write-file-hooks':  
;; (add-hook 'write-file-hooks ...) found in: http://calypso.tux.org/pipermail/xemacs-patches/2008-March/001493.html (Didier Verna)
;; To check (and possibly fix if `whitespace-auto-cleanup' is set) whitespace
;; problems automatically but only when saving buffers, you can add the
;; function `whitespace-write-file-hook' to your `write-file-hooks'.
   (add-hook 'write-file-hooks 'whitespace-write-file-hook)
;;; add `whitespace-write-file-hook' to the `find-file-hooks': 
;; add this to check for whitespace, if a file is opened (the file had been found): 
   (add-hook 'find-file-hooks 'whitespace-write-file-hook)

;; define which white spaces should be visuable 
  (setq whitespace-style '(trailing newline tab-mark newline-mark))

;; To check (and possibly fix if `whitespace-auto-cleanup' is set) whitespace
;; problems automatically on new buffers, you can turn
;; `whitespace-global-mode' on.
  (setq whitespace-global-mode nil)

;; Global variable to check `whitespace' at `end-of-line'
  (setq whitespace-check-ateol-whitespace t)
;; leave allone leading whitespace
  (setq whitespace-check-leading-whitespace nil)

;;;; Library Make whitespace visable -----------------------------------------------------
;     (autoload 'whitespace-visual-mode "whitespace-visual-mode" 
;       "Toggle whitespace visual mode.
;	With arg, turn whitespace visual mode on iff arg is positive.
;	In whitespace visual mode the different whitespaces (tab, blank return)
;	are highlighted with different faces. The faces are:
;	`whitespace-visual-blank-face', `whitespace-visual-tab-face' and 
;	`whitespace-visual-return-face'."
;	t)
;;
;     (autoload 'whitespace-visual-incremental-mode "whitespace-visual-mode" 
;	  "Toggle whitespace visual incremental mode.
;        With arg, turn whitespace visual incremental mode on iff 
;        arg is positive. In whitespace visual incremental mode 
;	the different whitespaces (tab and blank) are highlighted with 
;	different faces. The faces are: `whitespace-blank-face' and 
;        `whitespace-visual-tab-face'. Use the command 
;	`whitespace-visual-show-faces' to show their values.
;	In this mode only these tabs and blanks are highlighted, which are in 
;	the region from (point) - (window-height) to (point) + 
;	(window-height)."
;        t)


;;;; change char set
;; -------------------------------------------------------------------
;; bat-mode.el; Author: Adrian Aichner <adrian@xemacs.org>
(autoload 'bat-mode "bat-mode" "bat-mode Editing Mode" t)
(setq auto-mode-alist
 	 (append '(("\\.bat\\b"  . bat-mode))
 		 auto-mode-alist))
 (add-hook 'bat-mode-hook 'turn-on-font-lock)
 ;(modify-coding-system-alist 'file "\\.bat\\'" 'iso-ascii)
 ; have not yet found a library for the OEM-charset
 ; perhaps 'recode.el' can help
;; -------------------------------------------------------------------
;;;; behave like a Program under MS-Windows
;;
;;; pending-delete-mode causes typed text to replace a selection,
;;; rather than append -- standard behavior under all window systems
;;; nowadays.
(load "pending-del")
(pending-delete-mode 1)
;;; enable region selection with shift+arrows (on by default in 21.5
;;; and up)
(setq shifted-motion-keys-select-region t)
;;-------------------------------------------------------------------------------------------
;;;; format: column width, auto-fill-mode, auto-indent, linebreak after fill-column
(setq-default fill-column 120) ; column width, (Textbreite)
;; enable auto-formating, -line-wrapping, -indent
(add-hook 'text-mode-hook 'turn-on-auto-fill) ; turn on auto-fill-mode
;; indent-line
(setq default-major-mode 'indented-text-mode)
(setq indent-line-function 'indent-relative-maybe) ;; from xemacs help-file
;;-------------------------------------------------------------------------------------------
;;;; dired.el
;(load "dired") ;; to use it together with `recent-files', it has to loaded first.

;;-------------------------------------------------------------------------------------------
;;;; recent-files.el
;;;  provides a menu: `Recent_Files', with a list of the recently opened files
;;(load "recent-files")
(require 'recent-files)
(recent-files-initialize)
(setq recent-files-number-of-entries 35)
;;; In order to use recent-files with `dired', `dired' has to be loaded first.  
;;-------------------------------------------------------------------------------------------

;;;; Autosave-Files at one Place   (from sample.init.el)
;;
;; ********************
;; Put all of your autosave files in one place, instead of scattering
;; them around the file system.  This has many advantages -- e.g. it
;; will eliminate slowdowns caused by editing files on a slow NFS
;; server.  (*Provided* that your home directory is local or on a
;; fast server!  If not, pick a value for `auto-save-directory' that
;; is fast fast fast!)
;;
;; Unfortunately, the code that implements this (auto-save.el) is
;; broken on Windows in 21.4 and earlier.
(unless (and (eq system-type 'windows-nt)
	     (not (emacs-version>= 21 5)))
  (setq auto-save-directory (expand-file-name "~/.autosave/")
	auto-save-directory-fallback auto-save-directory
	auto-save-hash-p nil
	efs-auto-save t
	efs-auto-save-remotely nil
	;; now that we have auto-save-timeout, let's crank this up
	;; for better interactive response.
	auto-save-interval 2000
	)
  ;; We load this afterwards because it checks to make sure the
  ;; auto-save-directory exists (creating it if not) when it's loaded.
  (require 'auto-save)
  )
;;;; --- func-menu.el -----------------------------------------------------------
;; Support for non X Window versions of Emacs:
;; ===========================================
;; This package can also be used for non X versions of Emacs. In this case,
;; only modeline display and completing read input from the minibuffer are
;; possible.
;; (add-hook 'find-file-hooks 'fume-setup-buffer) ;; this line collides with AUCTeX, 
;; don't use it. This will disable for example some key bindings for LaTeX-mode. 
;;; The following is the AUCTeX compatible code of Stephen J. Turnbull to enabel 
;;; find file-file-hooks outside latex- and tex-mode: 
(defun polatexly-correct-fume-setup-buffer ()
  (unless (memq major-mode '(LaTeX-mode latex-mode tex-mode))
    (fume-setup-buffer)))
(add-hook 'find-file-hooks 'polatexly-correct-fume-setup-buffer)
;;; --- End code of Stephen J. Turnbull ---
(add-hook 'Manual-mode-hook 'turn-on-fume-mode)
;;; ------ End of func-menu.el ----------------------------------------------------
;;;; resize-minibuffer -------------------------------------------------------------
;;;; ********************
;;; resize-minibuffer-mode makes the minibuffer automatically
;;; resize as necessary when it's too small to hold its contents.
(when (fboundp 'resize-minibuffer-mode)
  (resize-minibuffer-mode)
  (setq resize-minibuffer-window-exactly nil))
;;;;   ------- END resize-minibuffer ---------------------------------------------
;
;;;;   ------  gnuserver ---------------------------------------------------------
;;   XEmacs start as multi instance one. The GNUserv provides an instance mode,
;;   this is good for inverse search with yap (mikTeX): 
;;   The command to configure yap for inverse search is:
;;   "C:\Program Files\XEmacs\XEmacs-21.4.13\i586-pc-win32\gnuclientw.exe" -F +%l "%f"
;;   To use inverse search you have to install a special gnuserv 
;;   for win32, I took `gnuserv-2.1p1.zip', this is for ntemacs, but it works with
;;   win32-xemacs too, but you have to start xemacs first, perhaps there is although
;;   a version for xemacs, you need this while winclient.exe is not able to pass line
;;   number to xemacs.
;;   Read also the info-File `readme.nt' of this zip-File
;;   rename the original `gnuserv.el' that is shiped with your xemacs and copy in this
;;   destination the `gnuserv.el' of the `gnuserv-2.1p1.zip' pakage and byte-compile it.
;;  (for locations see at the end of the file)
(gnuserv-start)
(setq gnuserv-frame (selected-frame))
;;; attention!!! I had also to edit custom.el,
;;; I inserted in custom.el `'(gnuserv-frame (selected-frame))', now it looks like:
;;; (custom-set-variables
;;;   '(column-number-mode t)
;;;   '(gnuserv-frame t)
;;;   '(gnuserv-frame (selected-frame))
;;;   '(server-make-window-visible t)
;;;   '(font-lock-mode t nil (font-lock))
;;;   '(modeline-scrolling-method (quote scrollbar)))
;;  * * *
;;; Here another comment, Omri Guttman told me, found in:
;;; (http://list-archive.xemacs.org/xemacs-nt/199909/msg00023.html)
;; 
;;; > (1) (error/warning) Error in process filter: (void-function
;;; > gnuserv-edit-files-quickly)
;;;
;;; I had similar problems, and hacked this together: give it a try, I do not
;;; know if it will solve your problem. I have been using it for a few months
;;; now,
;;; and it works mostly fine. Sometimes I get problems with files not being
;;; found by XEmacs
;;; when using gnuclient, but only if the files contain spaces: must be a
;;; Explorer problem
;;; invoking gnuclient.
;;;
;;;; This function is needed I guess because we use gnuclient, but with XEmacs
;;;; instead of Gnu Emacs:
;;    (defun server-edit-files-quickly (list &rest flags)
;;      (gnuserv-edit-files '(mswindows) list (or flags 'quick)))
;;    (defun server-edit-files (list &rest flags)
;;      (gnuserv-edit-files '(mswindows) list))
;;;;;------End xemacs base configuration------------------------------------------------

;;;;; ------ Octave-mode ---------------------------------------------------------------
;; a tip from Jason Mobarak, http://cs.unm.edu/~jmob/windows-octave.txt
;; Octave under Windows using XEmacs and Cygwin
;; If you are a MS-WIN32 user and not working under linux emulation "cygwin" things may be different
;; I don't know the reason
  (setenv "DISPLAY" "127.0.0.1:0.0")
;; know you have to make three folders:
;; %homepath%\.xemacs\bin
;; %homepath%\.xemacs\xemacs-packages
;; %homepath%\.xemacs\xemacs-packages\lisp
;; for me %homepath% is "c:\", if you are not sure what it is on your machine, 
;; type %homepath% into your MS-file-explorer
;; (setq exec-path (cons "~/.xemacs/bin" exec-path))
;; the following adds a string to the list of strings `exec-path', here it is the 
;; location of the binary `octave.exe'
  (setq exec-path (cons "C:\\Programme\\Octave\\3.2.0_gcc-4.3.0\\bin" exec-path)) 

;; autolad octave mode for *.m-files
  (autoload 'octave-mode "octave-mod" nil t)
  (setq auto-mode-alist
      (cons '("\\.m$" . octave-mode) auto-mode-alist))

;; to turn on the abbrevs, auto-fill and font-lock features automatically  
  (add-hook 'octave-mode-hook
    (lambda ()
      (abbrev-mode 1)
      (auto-fill-mode 1)
      (if (eq window-system 'x)
        (font-lock-mode 1))))

;; And finally, inferior-octave-mode-hook is run after starting the process and putting
;; its buffer into Inferior Octave mode. Hence, if you like the up and down arrow keys to
;; behave in the interaction buffer as in the shell, and you want this buffer to use nice colors:    
  (add-hook 'inferior-octave-mode-hook
    (lambda ()
      (turn-on-font-lock)
      (define-key inferior-octave-mode-map [up]
        'comint-previous-input)
      (define-key inferior-octave-mode-map [down]
        'comint-next-input))) 
;; RET adds a newline and indents it, C-M-TAB and C-SPC complete symbol 
  (add-hook 'octave-mode-hook 
    (lambda ()
      (define-key octave-mode-map "\C-m"
          'octave-reindent-then-newline-and-indent)
      (define-key octave-mode-map [(control space)]
          'octave-complete-symbol)
      (define-key octave-mode-map [(meta control tab)] 
          'octave-complete-symbol)
     )    ) ;;end add-hook 'octave-mode-hook
;; change menu-entry
;; - Function: easy-menu-change PATH NAME ITEMS
;;     Change an existing menu.
;;     The menu must already exist and be visible on the menu bar.
;;     PATH is a list of strings used for locating the menu on the menu bar.
;;     NAME is the name of the menu.
;;     ITEMS is a list of menu items, as defined in `easy-menu-define'.
;;; Menu
;; (defun octave-add-octave-menu ()
;;   "Adds the `Octave' menu to the menu bar in Octave mode."
;;   (require 'easymenu)  
;;   (easy-menu-define octave-mode-menu-map octave-mode-map
;; 		    "Menu keymap for Octave mode." octave-mode-menu)
;;   (easy-menu-add octave-mode-menu-map octave-mode-map))


  (add-hook 'octave-mode-hook
    (lambda ()
      ;(easy-menu-change '("Octave") "Complete Symbol"
      ;  (list ["Complete Symbol"              octave-complete-symbol t]))
      ; `list' gives a submenu :-(
      (easy-menu-change '("Octave") "Complete Symbol"
         ["Complete Symbol2"              octave-complete-symbol t])
      (easy-menu-add-item '("Octave") nil 
          ["Complete Symbol3"             octave-complete-symbol [ :keys "\C-SPC" :active t ] ])
      (easy-menu-add-item '("Octave") "Complete Symbol4" 
          ["Complete Symbol4"             octave-complete-symbol t])
    )
  )


;; run an inferior Octave process in a special Emacs buffer
  (autoload 'run-octave "octave-inf" nil t)

;; if you have the win32 version of octave
;  (add-hook 'inferior-octave-mode-hook
;       '(lambda ()
;           ;(setq inferior-octave-program
;           ;    "C:\\Programme\\GNU Octave 2.1.73\\bin\\octave-2.1.73.exe")
;           (setq inferior-octave-program
;               "C:\PROGRA~1\GNUOCT~1.73\bin\OCTAVE~1.EXE" -q)
;        )
;  )

;;
;; If `gnuserv' is installed, add the lines
  (autoload 'octave-help "octave-hlp" nil t)
  (require 'gnuserv)
  (gnuserv-start)      

;;
(defvar inferior-octave-program "octave"
  "*Program invoked by `inferior-octave'.")
;; `gnuplot-info-lookup-symbol' looks at the Gnuplot info file 
;;  the file gnuplot.info must be placed somewhere where info can find it, 
;;  C:\\Program Files\\XEmacs\\xemacs-packages\\info
;;  A line like this in your .emacs allows you to
;;  put gnuplot.info any place convenient:
;;  (add-to-list 'Info-default-directory-list "/path/to/file")

;;;;; ------ Gnuplot-mode --------------------------------------------------------------
;; Lines enabling gnuplot-mode
;; move the files gnuplot.el, gnuplot-gui.el and info-look.20.3.el to someplace in your 
;; lisp load-path or use a line like
;;  (setq load-path (append (list "/path/to/gnuplot/el") load-path))
;; for me the right place was:
;; C:\\Program Files\\XEmacs\\xemacs-packages\\lisp\\gnuplot
;; and byte compile both

;; these lines enable the use of gnuplot mode
  (autoload 'gnuplot-mode "gnuplot" "gnuplot major mode" t)
  (autoload 'gnuplot-make-buffer "gnuplot" "open a buffer in gnuplot mode" t)

;; add `gnuplot-mode' to the list `whitespace-modes' 
  (setq whitespace-modes (cons 'gnuplot-mode whitespace-modes))
;; this is done above:
  
;; this line automatically causes all files with the .gp extension to
;; be loaded into gnuplot mode
  (setq auto-mode-alist 
     (append 
        (list
           '("\\.gp$" . gnuplot-mode)
           '("\\.plt$" . gnuplot-mode)
        ) 
      auto-mode-alist))

;; This line binds the function-9 key so that it opens a buffer into
;; gnuplot mode 
;;  (global-set-key [(f9)] 'gnuplot-make-buffer)

;; if you have the latest win32 version of gnuplot
(add-hook 'gnuplot-load-hook
                   '(lambda ()
                        (setq gnuplot-program
                              "C:\\Programme\\gnuplot\\gnuplot4.4\\bin\\pgnuplot.exe")
                        (setq gnuplot-gnuplot-buffer "plot.plt")
                        ; (setq show-trailing-whitespace t)
                        (setq whitespace-auto-cleanup t)
                        (setq whitespace-check-buffer-ateol t)
                    ))
;;; 
(add-hook 'gnuplot-mode-hook 
  '(lambda ()
      ; control key bindings
      (define-key gnuplot-mode-map '[(control meta q)] 'at_sign)          ;;  `octal code for @ sign'
      (define-key gnuplot-mode-map '[(control _)] 'lower_index)           ;; lower index _{}
      (define-key gnuplot-mode-map '[(control ^)(control ^)] 'exponent)   ;; exponent ^{}
      (define-key gnuplot-mode-map '[(control c)(control a)] 'gnuplot-send-buffer-to-gnuplot)   ;; send buffer to gnuplot
      (define-key gnuplot-mode-map '[(meta button1)] 'mouse-track-do-rectangle) ;; mark rectangle
    )    ) ;;end add-hook 'gnuplot-mode-hook

;; end of line for gnuplot-mode                              
;;;;; ------ LaTeX ---------------------------------------------------------------------
;;;; ltx-help.el (part of miktex package "latex2e-help-texinfo.cab" or "latex2e-help-texinfo-src.tar.bz2") --- 
;; Lookup latex commands in info pages (part of miktex).
;; I have not managed to install it properly, especially jumping
;; to the help of the current command, perhaps someone can give me a tip?
;; But I can jump to the latex-help and search inside the help-file.
;; To do: copy the directory of ltx-help.el into the "lisp" directory of your xemacs,
;; e.g.: "C:\\Program Files\\XEmacs\\xemacs-packages\\lisp\\", 
;; load "ltx-help.el" into your xemacs and compile the lisp-file with the function call
;; "M-x byte-compile-buffer" RET,
;; load "latex2e.texi" into your xemacs, make info files for xemacs with the  
;; function call: `M-x texinfo-format-buffer' copy the info files `latex' `latex-1' 
;; [...] `latex-n' (that you have created) to the `info'-directory
;; of your xemacs, e.g. "C:\\Program Files\\XEmacs\\XEmacs-21.4.13\\info"
;; Now you are ready to use the latex-help to look up a latex command or
;; environment in the latex online manual.  If point is at such a
;; command, this will be the default.
(load "ltx-help")

;; Bind latex-help to C-h C-l:
; (define-key help-map [(control h)(control l)] 'latex-help)
(define-key help-map "\C-l" 'latex-help)

;; To load latex-help when loading AUC-TeX or some other LaTeX/TeX mode 
;; and bind the it to C-C i key (you need add-hook, a very nice package).
;; Key binding is done below with the other key-bindings for the latex mode.
;;;---- end ---- ltx-help.el ---- end -----------------------------------------------

;;;; ---- x-symbol  ---  nice symbols for LaTeX text code -----------------------
;; Under MS-Windows with XEmacs, X-Symbol just supports a limited number of characters 
;; (Latin-1, Latin-5, and half the math symbols) and no super- and subscripts, due to 
;; missing MS-Windows fonts (*note Wishlist Fonts::).
;; This package require package `font-lock' (distributed with Emacs and XEmacs), the use 
;; of package `lazy-shot' is recommended, see *NoteSyntax Hiliting Packages::.
;; Images are not yet supported under MS-Windows. For more Informations try the functions:
;; `M-x' `x-symbol-package-info' and   `M-x' `x-symbol-package-web' 
(x-symbol-initialize)
;; x-symbol: load the recomended package `lazy-shot':
(add-hook 'font-lock-mode-hook 'turn-on-lazy-shot)
;; Do not use `lazy-shot' in combination with lazy-lock.
;; lazy-lock doesn't have a variable for its modeline name, so we have
;; to do a bit of surgery.
(and (assoc 'lazy-lock-mode minor-mode-alist)
     (setcdr (cdr (cadr (assoc 'lazy-lock-mode minor-mode-alist))) ""))

;;;; latex-math-symbol.el --- LaTeX math symbol decoder
;; This file is part of MU (Message Utilities).
;; Keywords: LaTeX, math, mule
;;  my version of `latex-math-symbol.el' was incompatible with my auctex
;(autoload 'latex-math-decode-buffer "latex-math-symbol" nil t)
;(add-hook 'mime-viewer/plain-text-preview-hook
;          'latex-math-decode-buffer)
;;; ---- END latex-math-symbol.el ------------------------------------------------------
;;;; --- Sumatra-PDF-Viewer ------------------------------------------------------------
(require 'sumatra-forward)
;;;; --- AUC TeX -----------------------------------------------------------------------
(require 'tex-mik) ;; please read the file install.windows
                   ;; don't use (require 'tex-site) if you use "miktex"
;;;   If you want to make AUC TeX aware of style files and multi-file
;;;   documents right away, insert the following in your `init.el' file.
(setq TeX-parse-self t)             ; Enable parse on load.
(setq TeX-auto-save t)              ; Enable parse on save.
;(setq-default TeX-master nil)      ; Query for master file. (can be annoying)
(setq-default TeX-master t)         ; Don't query for master file. Every new file is Master.
;(setq-default TeX-master "master") ; All master files called "master" (I don't like it).
;;
;;; change in macro-completion-mode after hitting `\'
(setq TeX-electric-escape t) ;turn on macro-completion-mode after hitting `\'
;;; Inverse search, Source Specials
;; Source Specials will move the DVI viewer to the location corresponding to point 
;; (forward search), and it will use emacsclient or gnuclient to have the previewer 
;; move Emacs to a location corresponding to a control-click in the previewer window.
;; It has to be stressed very strongly however, that Source Specials can cause diferences
;; in page breaks, in spacing, can seriously interfere with various packages and should
;; thus never be used for the final version of a document. In particular, fine-tuning the
;; page breaks should be done with Source Specials switched off.
;; You can permanently activate TeX-source-specials-mode with
(setq TeX-source-specials-mode 1)

;;; PDFTeX
;;  If this is set, DVI will also be produced by calling PDFTEX, setting \pdfoutput=0.
;;  This makes it possible to use packages like "pdfcprot" even when producing DVI files.
(setq TeX-DVI-via-PDFTeX t)

;;;   - Variable: TeX-auto-regexp-list
;;    Parse all TeX and LaTeX commands that AUC TeX can use constant: 'TeX-auto-full-regexp-list.
(setq-default TeX-auto-regexp-list 'TeX-auto-full-regexp-list)

;;; Automatic Customization for the Site (be careful with blanks in directories, mask them with `\')
;; It is not necessary to use double back slashes under MS-OS (e.g. MS-WINXP)
;; Dont use the simple form of `setq'
;; this was wrong for me: (setq TeX-macro-global (cons "C:/Programme/MiKTeX\ 2.8/tex/" TeX-macro-global))
;; Instead define a list, if you wish you can add, further directory to this list:
;; (setq foo-list '("c:/foo1/
;;                  "c:/foo2/
;;                  ))
;; Always terminate the directory with a slash `/'
;; Use `M-x TeX-auto-generate-global' to extract the global information.
(setq TeX-macro-global '("C:/Programme/MiKTeX\ 2.8/tex/"
                        ))

;;; Automatic Customization for a User
;; You should specify where you store your private TEX macros, so AUCTEX can extract
;; their information. The extracted information will go to the directories listed in TeX-autoprivate
;; Use `M-x TeX-auto-generate' to extract the information.
;(setq TeX-macro-private "C:/home/stefan_pofahl/Dokumente/L/LaTeX/macros/")
;(setq TeX-macro-private "C:\\home\\stefan_pofahl\\Dokumente\\L\\LaTeX\\macros\\")
(setq TeX-macro-private '("C:/home/stefan_pofahl/Dokumente/L/LaTeX/macros/\\"
			 ))


;;;  To get a full featured LaTeX-section command, insert:
(setq LaTeX-section-hook
  '(LaTeX-section-heading
    LaTeX-section-title
    LaTeX-section-toc
    LaTeX-section-section
    LaTeX-section-label))
;;; Set View Options
(setq TeX-output-view-style (quote (("^dvi$" "^pstricks$\\|^pst-\\|^psfrag$" "dvips %d -o && start %f") 
                                 ("^dTeX-output-view-stylevi$" "." "yap -1 %dS %d") 
                                 ("^pdf$" "." "SumatraPDF-TeX.exe %o") 
                                 ("^html?$" "." "start %o"))
                         )
)
;;;   ----------- german quotation   -------------------------------------------------
;; if you have an old auctex this works but is not fine
;       (setq TeX-open-quote "\"`")
;       (setq TeX-close-quote "\"'")
;       (setq TeX-quote-after-quote 't)
;; or bit more clever:
;   (add-hook 'LaTeX-mode-hook
;     (function (lambda ()
;       ;;
;       ;; 1. besondere Behandlung fuer dt. Texte (u.a. fuer ")
;       (TeX-run-style-hooks "german")  ;; nur AucTeX
;       ;;
;       ;; 2. turn off special behavior of key " 
;       ; (local-set-key "\"" 'self-insert-command)
;       ;; 3. only insert " instead of ``...'':
;       ; (setq TeX-open-quote "\"")
;       ; (setq TeX-close-quote "\"")
;       ;;
;       ;; 4. insert "`..."' instead of ``...'':
;       (setq TeX-open-quote "\"`")
;       (setq TeX-close-quote "\"'")
;       ;; 5. Determines the behavior of the key ". If it is non-nil, 
;       ;; typing " will insert a literal double quote. 
;       ;; The respective values of LaTeX-german-open-quote 
;       ;; and LaTeX-german-close-quote 
;       ;; will be inserted after typing " once again.
;       ;(setq TeX-quote-after-quote 't)
;       )))
;; if you have auctex vers. 11.50 or newer that is better but for me it is not working
;; perhaps you find out what the trick is:
  (setq LaTeX-german-open-quote "\"`")
  (setq LaTeX-german-close-quote "\"'")
  (setq LaTeX-german-quote-after-quote 't)
;; Auto-Fill-Mode, auto indention, auto line break
  (add-hook 'LaTeX-mode-hook 'turn-on-auto-fill)
;; wrap lines before special characters: LaTeX-fill-break-at-separators
  (setq LaTeX-fill-break-at-separators '("$$" "\(\)" "\[\]"))
;; Default position for floats
  (setq LaTeX-float "htb")
 

;;; ----------------------------------------------------------------------------------
;;; some more menu entries in the command list:
;;; see tex-mik.el from package auctex: %v is defined in tex-mik.el
;;; other variables are defined in tex.el from auctex
;;; the meaning of some auctex-varibles:
        ;symbols defined in tex.el in "TeX-expand-list":
        ;%b name slave tex-file    %d dvi-file  %f ps-file 
        ;%l "latex"
        ;%n line number  %p printcommand  %q "lpq"  %r (TeX-style-check TeX-print-style)
        ;%s master-file-name without extention
        ;%v yap command view line
        ;%t name of current command file: master-file or buffer or _region_.tex 
        ;%o may be pdf-file (I don't know exactly)
;;;; ---- Begin of own Command Menu Entries entries: ------------------------------------
;;; Put your first entry at the End of the list.
;; there are some more suggestion in my old init.el, see there
;; TeX-command-list is defined in tex.el
;; You have five arguments: 1.)name, 2.)command, 
;; 3.) The function which actually start the process.
;; Several such hooks has been defined, e.g. "TeX-run-discard" (see "tex-buf.el")
;; 4.) If the fourth element is non-nil, the user will get a chance to
;; modify the expanded string.
;; 5.) The fifth element indicates in which mode(s) the command should be
;; present in the Command menu.  Use t if it should be active in any
;; mode.  If it should only be present in some modes, specify a list with
;; the respective mode names.
;; So if you want to check a new entry in the menu, change the fourth argument to "t"
;; The function "TeX-run-command" has the advantage, that it sends a message after run
;; and you can see the terminal messages   
 (eval-after-load "tex"
   '(progn
      (add-to-list 'TeX-command-list
	(list "---- end-custom-menue ----------------------------" "")
      )
      (add-to-list 'TeX-command-list
        (list "Check with new lacheckw32" 
          "lacheckw32 %s" 'TeX-run-compile nil t)
      )
      (add-to-list 'TeX-command-list
        (list "View Log File" 
          "\"C:\\Programme\\XEmacs\\XEmacs-21.4.22\\i586-pc-win32\\gnuclientw.exe\" -q -F %s\.log" 
          'TeX-run-discard nil nil)
      )

;;; for command evaluation / zum berprfen der Variablenwerte:
;      (add-to-list 'TeX-command-list
;         (list	"View-Command" "echo b %b pdfout %(PDFout) t %t %dS %d  > c:\\bla.txt" 
;         'TeX-run-discard t nil)
;      )
;; ---
     (add-to-list 'TeX-command-list
        (list	"View-Line" "\"%V\"" 
        'TeX-run-discard nil nil)
     )
     (add-to-list 'TeX-command-list
        (list "Ghostview PS" "echo.C:\\Programme\\Ghostgum\\gsview\\gsview32.exe -t1 -e %f" 
         'TeX-run-discard nil nil)
     )
     (add-to-list 'TeX-command-list
        ;; for old miktex or if you don't have pdfopen.exe (part of live-tex-distribution)
        ; (list "Acrobat Reader" 
        ;  "\"C:\\Programme\\Adobe\\Acrobat 6.0\\Reader\\acrord32.exe\" %s\.pdf"
        ; 'TeX-run-discard nil nil)
        ;; for new miktex (>v2.5) with pdfopen.exe
        (list "Acrobat Reader" 
          "pdfopen --file=%s\.pdf"
            'TeX-run-discard nil nil)
        ;; or with batch file openpdf.bat
;        (list "Acrobat Reader" 
;          "\"C:\\Programme\\MiKTeX\ 2.8\\miktex\\bin\\openpdf.bat\" %t"
;            'TeX-run-discard t t)
     )
      (add-to-list 'TeX-command-list
        (list "Ghostview pdf" "C:\\Programme\\Ghostgum\\gsview\\gsview32.exe -t1 -e %s\.pdf" 
        'TeX-run-discard nil nil)
      )     
      (add-to-list 'TeX-command-list
	(list "---- view commands -------------------------------" "")
      )
      (add-to-list 'TeX-command-list
        (list "BibTeX-8bit" "bibtex8 -H --8bit %s" 
          'TeX-run-BibTeX nil nil)
      )
      (add-to-list 'TeX-command-list
        (list "Mount C" 
          "\"C:\\Programme\\cygwin\\bin\\mount.exe\" -f c: /"
          'TeX-run-shell t nil)
      )
      (add-to-list 'TeX-command-list
	(list "---- else -----------------------------------------------" "")
      )
     (add-to-list 'TeX-command-list
        ; old version without batchfile
        ; (list "Texify pdf" "texify --clean --pdf --batch %t" 
        ; 'TeX-run-command nil t) 
        (list "Texify pdf" 
          "\"C:\\Programme\\MiKTeX\ 2.8\\miktex\\bin\\texify.exe\" --pdf %t"
          'TeX-run-command nil t) 
     )
     (add-to-list 'TeX-command-list
        (list "Close PDF-File" "pdfclose --file=%s\.pdf"
        'TeX-run-discard nil nil) 
     )
     ;; this produces smaller pdf-files than `texify --pdf', but it works only interaktive,
     ;; you have to input the pdf-file-name manually, perhaps someone has a better idea for that 
      (add-to-list 'TeX-command-list
        (list "Ghostview PS->PDF" 
         "C:\\Programme\\Ghostgum\\gsview\\gsview32.exe -t1 -fpdfwrite -r600x600 -sOutputFile=\"%s.pdf\" \"%f\"" 
         'TeX-run-discard nil nil)
     )
     (add-to-list 'TeX-command-list
        (list "gscript PS-> PDF" 
         "C:\\Programme\\Ghostgum\\gs\\gs8.63\\bin\\gswin32c.exe -dNOPAUSE -q -sDEVICE=pdfwrite -r600x600 -sOutputFile=\"%s.pdf\" -dBATCH \"%f\"" 
         'TeX-run-command nil nil)
     )
     (add-to-list 'TeX-command-list
     ;;; here is the code of the needed batchfile:
     ;; @echo off
     ;; REM latex2dvi2ps2pdf.bat, vers.2
     ;; REM %1 name %2 tex
     ;; SET f_tex=%1.tex
     ;; SET f_dvi=%1.dvi
     ;; SET f_ps=%1.ps
     ;; SET f_pdf=%1.pdf
     ;; C:\windows\system32\kill.exe AcroRd32
     ;; C:\Programme\miktex\texmf\miktex\bin\texify.exe --quiet %f_tex%
     ;; C:\Programme\miktex\texmf\miktex\bin\dvips.exe %f_dvi% -N0 -Pamz -Pcmz -G0 -o %f_ps% 
     ;; "C:\\Programme\\Ghostgum\\gs\\gs8.00\\bin\\gswin32c.exe" -dNOPAUSE -q -sDEVICE=pdfwrite -r600x600 -sOutputFile=%f_pdf% -dBATCH %f_ps%
     ;; call "C:\Programme\Adobe\Acrobat 5.0\Reader\acrord32.exe" %f_pdf%
     ;; echo --------------------------------------------------------------------------
     ;; echo latex2dvi2ps2pdf: Done!
     ;;; ------------------
        (list "latex2dvi2ps -> PDF -> acrobat" 
          "\"C:\\Programme\\MiKTeX\ 2.8\\miktex\\bin\\latex2dvi2ps2pdf.bat\" %t"
     ;   'TeX-run-discard nil nil)
        'TeX-run-command t t)
     )
     ;; ------------------------------------------------------------------------------------
     ;; @echo off
     ;; REM latex2dvi2ps2pdf.bat
     ;; REM %1 name %2 tex
     ;; SET f_dvi=%1.dvi
     ;; SET f_ps=%1.ps
     ;; SET f_pdf=%1.pdf
     ;; C:\windows\system32\kill.exe AcroRd32
     ;; C:\Programme\miktex\texmf\miktex\bin\texify.exe --tex-opt=--src --quiet %2
     ;; C:\Programme\miktex\texmf\miktex\bin\dvips.exe %f_dvi% -N0 -Pamz -Ppdf -G0 -o %f_ps% 
     ;; "C:\Programme\Ghostgum\gs\gs8.00\bin\gswin32c.exe" -dNOPAUSE -q -sDEVICE=pdfwrite -r600x600 -sOutputFile=%f_pdf% -dBATCH %f_ps%
     ;; call "C:\Programme\Adobe\Acrobat 5.0\Reader\acrord32.exe" %f_pdf%
     ;; echo --------------------------------------------------------------------------
     ;; echo latex2dvi2ps2pdf: Done!
     ;; ------------------------------------------------------------------------------------
     ;; dvipdfmx.exe is beatiful miktex-programm, but I don't know which map is the best, you have to try yourself
     (add-to-list 'TeX-command-list
        (list "DVI -> DVIPDFM_extended-> PDF" 
          "\"C:\\Programme\\MiKTeX\ 2.8\\miktex\\bin\\dvipdfmx.exe\" -o %s.pdf %d"
        'TeX-run-command nil nil)
     )
     (add-to-list 'TeX-command-list
        (list "DVI -> DVIPDFM -> PDF" 
          "\"C:\\Programme\\MiKTeX\ 2.8\\miktex\\bin\\dvipdfm.exe\" -o %s.pdf %d"
        'TeX-run-command t t)
     )
     ;; ------------------------------------------------------------------------------------
     ;; REM code for batchfile dvipdfmx.bat, kill.exe is part of the recource kit from MS
     ;; @echo off
     ;; C:\windows\system32\kill.exe AcroRd32.exe
     ;; C:\Programme\miktex\texmf\miktex\bin\texify --tex-opt=--src --quiet %1
     ;; C:\Programme\miktex\texmf\miktex\bin\dvipdfmx.exe -f dvipdfm_ndl14.map -o %2 %3
     ;; call "C:\Programme\Adobe\Acrobat 5.0\Reader\acrord32.exe" %2
     ;; echo --------------------------------------------------------------------------
     ;; echo Done!
     ;; ------------------------------------------------------------------------------------
     (add-to-list 'TeX-command-list
        (list "batch file TEX -> DVIPDFM.EXE -> PDF" 
          "\"C:\\Programme\\MiKTeX\ 2.8\\miktex\\bin\\dvipdfm.bat\" %t"
        'TeX-run-command t nil)
     ;   'TeX-run-command nil nil)
     )
     (add-to-list 'TeX-command-list
        (list "batch file TEX -> DVIPDFMX.EXE(extended DVIPDFM) -> PDF" 
          "\"C:\\Programme\\MiKTeX\ 2.8\\miktex\\bin\\dvipdfmx.bat\" %t"
        'TeX-run-command nil nil) 
     )
      ; 'TeX-run-command nil nil) ; you may see the output
      ; 'TeX-run-discard nil nil) ; mean xemacs is not waiting for an answer
 
      (add-to-list 'TeX-command-list
	(list "---- destill PDF Files --------------------------------" "")
      )
      (add-to-list 'TeX-command-list
        (list "tex -> HTML (\usepakage(tex4ht))"
         "htlatex %t" 
         'TeX-run-command nil nil)
      )
      (add-to-list 'TeX-command-list
	(list "---- create HTML Files --------- ---------------------" "")
      )
      (add-to-list 'TeX-command-list
        (list "DVIPS-> PS landscape for pdf"
         "dvips %d -N0 -Ppdf -G0 -T 297mm,210mm -o %f " 
         'TeX-run-command nil nil)
      )
;; tested on dvips version: dvips(k) 5.98, "-I 1" is the postscript level 1, possibel are also level 2 and 3
     (add-to-list 'TeX-command-list
        (list "DVIPS-> PS for pdf" "dvips %d -q -R0 -j0 -N0 -Ppdf -Pamz -Pcmz -Pdownload35 -G0 -I 1 -D 1200 -Z -mode dpdfezzz -o %f " 
        'TeX-run-command nil t)
     )
;; old version of "DVIPS-> PS for pdf":
;     (add-to-list 'TeX-command-list
;        (list "DVIPS-> PS for pdf" "dvips %d -N0 -Pamz -Ppdf -G0 -o %f " 
;        'TeX-run-command nil t)
;     )
     (add-to-list 'TeX-command-list
        (list "DVIPS-> PS normal" "dvips %d -N0 -Ppdf -Pamz -Pcmz -G0 -I 2 -D 600 -Z -mode dpdfezzz -o %f " 
        'TeX-run-command nil nil)
     )
      (add-to-list 'TeX-command-list
	(list "---- create Postscript Files ---------------------" "")
      )
      (add-to-list 'TeX-command-list
        ; older texify.exe
        ; (list "All Texify run-viewer"
        ;  "texify --tex-opt=--src --run-viewer --clean %t"
        ;  'TeX-run-command nil t)
        ; newer texify.exe
        ; MiKTeX Compiler Driver 2.5.2400 (MiKTeX 2.5)
        (list "All Texify run-viewer"
         "texify --src-specials --run-viewer --clean %t"
         'TeX-run-command nil t)
      )
      (add-to-list 'TeX-command-list
        ; older texify.exe
        ; (list "Texify" "texify --tex-opt=--src --quiet %t"
        ;  'TeX-run-command nil t)
        ; newer texify.exe
        ; MiKTeX Compiler Driver 2.5.2400 (MiKTeX 2.5)
        (list "Texify" "texify --src-specials --quiet %t"
         'TeX-run-command nil t)
      )
      (add-to-list 'TeX-command-list
        (list "PDFmode" "pdflatex -interaction=nonstopmode -synctex=-1 \"\\pdfoutput=1 \" \"\\input\" %t"
         'TeX-run-command t t)
      )
     (add-to-list 'TeX-command-list
        (list "Clean Dir" "del /q *.aux *.log %s.out %s.exa %s.ilg %s.idx %s.ind %s.lof %s.lot %s.toc %s.bbl %s.blg %s.dvi %s.ps %s.pdf %s.rel %s.xref %s.4tc %s.4ct %s.rip %s.idx TAGS .\\auto\\%s.el .\\auto\\ *.bak *.bix *~" 
         'TeX-run-discard nil nil) 
     )
     (add-to-list 'TeX-command-list
	(list "---- start-custom-menue --------------------------" "")
     )
   ) ; end of << '(progn  >>
 ) ; end of << (eval-after-load "tex" >>
        
;;;; ---- End of own Command Menu Entries entries: ------------------------------------

;;;;; ------- End AucTeX	------------------------------------------------------------
;; ----------------------------------------------------------------------------------------
;;;;; ------- RefTeX -----------------------------------------------------------------------
;; turns on RefTex: 
;(load "reftex")
(add-hook 'LaTeX-mode-hook 'turn-on-reftex)   ; with AUCTeX LaTeX mode
(add-hook 'latex-mode-hook 'turn-on-reftex)   ; with Emacs latex mode

(setq reftex-vref-is-default t)               ; vref is default
(setq reftex-toc-follow-mode t)
(setq reftex-extra-bindings t)
(setq reftex-enable-partial-scans t)
(setq reftex-save-parse-info t)
(setq reftex-use-multiple-selection-buffers t)
;; RefTeX contains code to interface with AUCTeX.  When this interface is
;; turned on, both packages will interact closely.
(setq reftex-plug-into-AUCTeX t)
;; Bib-cite version 3.06 and later can be configured so that bib-cite's
;; mouse functions use RefTeX for displaying references and citations.
;; This can be useful in particular when working with the LaTeX `xr'
;; package or with an explicit `thebibliography' environment (rather than
;; BibTeX).  Bib-cite cannot handle those, but RefTeX does.  To make use
;; of this feature, try
(setq bib-cite-use-reftex-view-crossref t)
;; Ref_tex  should look for labels also in equationarray environment
;; see documentation of ref-tex: 3.4.1 Theorem and Axiom Environments
(setq reftex-label-alist
  '(
     ("equationarray"   ?e "eq:"  "~\\vref{%s}" nil ("equation"   "eqa.") )
   )
)
(add-hook 'LaTeX-mode-hook
        (lambda ()
          (LaTeX-add-environments
            '("equationarray" LaTeX-env-array)
            )))
;;; ------- END RefTeX --------------------------------------------------------------------

;;;;; Spelling ****************************************************************************
;;; ispell ispell-local-dictionary-alist
;;; binaries are not includet in xemacs for win32, I took:
;;; "ispell-3.2.06-cygwin-1.3-bin.tar.gz.tar" and "cygwin1.dll",
;;; it works, but not fine, perhaps someone can add the necessary
;;; things here, I still have not found for example the file german8.hash 
;;; proper for ispell-3.2.06-cygwin-1.3.
;;; (for locations see at the end of the file)
;; load ispell
;;; UNCOMMENT THIS IF YOU HAVE AND WANT TO USE ISPELL
;;; I found the following line in an init.el example of Drew Adams on:
;;; http://www.emacswiki.org/emacs/emacs-init.el
(if (and (< emacs-major-version 21) (eq system-type 'windows-nt)) (require 'ispell))
;;; Key map for ispell menu.
;; Ispell.el will be loaded when something related to spelling is invoked and the
;; menu will be rebuilt at that time, although will show bad entries before.
(setq ispell-menu-xemacs nil)
(ispell-change-dictionary nil)
;;; on emacs (not xemacs)
;(setq ispell-menu-map nil)

;; When running ispell, consider all 1-3 character words as correct.
(setq ispell-extra-args '("-W" "3"))

;;; if you want to use umlauts enable "extended-character-mode" 
;;; Found on:
;;; http://www.kdstevens.com/~stevens/ispell-faq.html#get-ispell
M-x eval-expression
(ispell-get-extended-character-mode) 

;;;; ----- define language settings --------
(setq ispell-local-dictionary-alist
  '(
     ("US-xlg"				; US-american large version
      "[A-Za-z]" "[^A-Za-z]" "[']" nil ("-B" "-d" "US-xlg") nil iso-8859-1)
     (nil				; default (english.aff)
      "[A-Za-z]" "[^A-Za-z]" "[']" nil ("-B") nil iso-8859-1)
     ("UK-xlg"				; british-english large version
      "[A-Za-z]" "[^A-Za-z]" "[']" nil ("-B" "-d" "UK-xlg") nil iso-8859-1)
     ("deutsch"				; deutsch.aff
      "[a-zA-Z\"]" "[^a-zA-Z\"]" "[']" t ("-C") "~tex" iso-8859-1)
     ("deutsch8"
      "[a-zA-Z\304\326\334\344\366\337\374]"
      "[^a-zA-Z\304\326\334\344\366\337\374]"
      "[']" t ("-C" "-d" "deutsch") "~latin1" iso-8859-1)
   )
)

;;;german default dictionary
;(setq flyspell-default-dictionary "deutsch8")
;;;US-american large version default dictionary
(setq flyspell-default-dictionary "US-xlg")
;;;; ----- end german ---- 
;; use ispell in tex-mode
(setq ispell-parser 'tex)
;(setq ispell-parser 'latex)
(autoload 'ispell-word "ispell" "Check the spelling of word in buffer." t)
(autoload 'ispell-region "ispell" "Check the spelling of region." t)
(autoload 'ispell-buffer "ispell" "Check the spelling of buffer." t)
;;;
;;; Flyspell is a minor Emacs mode performing on-the-fly spelling
;;; checking.
;;;
;;; To install flyspell, add this to your ~/.emacs file:
;;;
;(autoload 'flyspell-mode "flyspell" "On-the-fly spelling checking" t)
;(autoload 'global-flyspell-mode "flyspell" "On-the-fly spelling" t)

;;;; --- customizing the key definitions --------------------------------------------------
;;; --- Keyboard-Macros ----
;(defalias 'korrektur
;  (read-kbd-macro "<right> 3*<backspace>"))
(defalias 'exponent
  (read-kbd-macro "^ {} <left>"))
(defalias 'neuezeile
  (read-kbd-macro "\\newline RET <right> RET"))
(defalias 'lower_index
  (read-kbd-macro "_{} <left>"))
(defalias 'cdot
  (read-kbd-macro "\\cdot RET <right> SPC <left>"))
(defalias 'at_sign
  (read-kbd-macro "\\\\100 SPC")) ;; octal representation of `@'-Symbol in Gnuplot Mode

;;;  --- LaTeX-mode-map -----

(add-hook 'LaTeX-mode-hook 
  '(lambda nil
      ; control key bindings
      (define-key LaTeX-mode-map '(control !) "\\!\n")  ;; negativ space `\!'
      (define-key LaTeX-mode-map '(control ,) "\\,\n")  ;; small space `\,'
      (define-key LaTeX-mode-map '(control \`) 'TeX-next-error)            ;; next error
      ;(define-key LaTeX-mode-map '[(control return)] "\\newline\n")       ;; newline (\f = C-f, \n = C-n)
      (define-key LaTeX-mode-map '[(control return)] 'neuezeile)           ;; newline
      (define-key LaTeX-mode-map '[(control _)] 'lower_index)              ;; lower index _{}
      (define-key LaTeX-mode-map '[(control )] 'exponent)                 ;; exponent ^{}
      (define-key LaTeX-mode-map '[(control ^)(control ^)] 'exponent)      ;; exponent ^{}
      (define-key LaTeX-mode-map '[(control *)] 'cdot)                     ;; \cdot{}
      ;(define-key LaTeX-mode-map '"\C-RET" "\\newline\n")                 ;; "\C-RET" = (control return); newline
      (define-key LaTeX-mode-map '[(control c)~] 'LaTeX-math-mode)         ;; LaTeX-math-mode
      ;(define-key LaTeX-mode-map '[(control c)(control a)] 'do-LaTeX)     ;; safe buffer, run latex
      ; (define-key LaTeX-mode-map '[(control c)(control a)] 'do-Texify)     ;; safe buffer, run texify
      (define-key LaTeX-mode-map '[(control c)(control a)] 'do-PDFmode)    ;; safe buffer, run pdflatex in pdf-mode
      (define-key LaTeX-mode-map '[(control c)(control t)] 'align-current) ;; align tabular regions
      (define-key LaTeX-mode-map '[(control c)(control v)] 'do-DVIview)    ;; view dvi-file (allready predefined)
      (define-key LaTeX-mode-map '[(control c)(control x)] 'do-PDF-close)  ;; Close PDF-file (allready predefined)
      (define-key LaTeX-mode-map '[(control h)(control l)] 'latex-help)    ;; view LaTeX-Help
      (define-key LaTeX-mode-map '(control f1) 'do-texify2DVIPDFMX)        ;; do texify2dvi2ps2pdf
      (define-key LaTeX-mode-map '(control f4) 'do-Texify)                 ;; do Texify
      (define-key LaTeX-mode-map '(control f5) 'do-PDF)                    ;; do PDF
      (define-key LaTeX-mode-map '(meta f12) 'do-TeX-And-View)             ;; compile and view Latex
    )    ) ;;end add-hook 'LaTeX-mode-hook

;;; see beneath for the definition of the functions bound to the keys.
;;; if you want to change the TeX-font selection command insert the following, the original 
;;; key binding `c-c c-f' collides with func-mode, (see above)
;;      (define-key LaTeX-mode-map '[(control c)(control v)] #'TeX-font)
;;;  --- END LaTeX-mode-map -----
;;; ------------------------------------------------------------------- 

;;; --- global key map ------------------------------------------------
; control key bindings
(global-set-key '(control backspace) 'backward-kill-word)    ;; kill word backward 
; meta key bindings
(global-set-key "\e$" 'ispell-word)            ;; meta-shift-$, spell word
; function key bindings
(global-set-key 'f1 'advertised-undo)          ;; Undo
(global-set-key 'f2 'kill-primary-selection)   ;; Cut
(global-set-key 'f3 'copy-primary-selection)   ;; Copy
(global-set-key 'f4 'yank-clipboard-selection) ;; Paste
(global-set-key 'f5 'find-file)                ;; C-x C-f
(global-set-key 'f7 'save-buffer)              ;; C-x C-s
(global-set-key [(f9)] 'gnuplot-make-buffer)   ;; opens a buffer into
                                               ;; gnuplot mode 
(global-set-key '(meta f9) 'auto-fill-mode)    ;; Toggle auto-filling. 
;;; --- global key map ------------------------------------------------

;;------------------------------------------------------------------------------------------
;;;; define functions that can be bind to key strokes
;; If you receive an error-message:
;; ----------------------------------------
;; While compiling the end of the data:
;;   ** the function TeX-command is not known to be defined.
;; ----------------------------------------
;; You can put the following before the definition,
;; because it is only a compiler warning:
(eval-when-compile
  (require 'tex)) ;; (tip from: David Kastrup)
;; 
(defun do-LaTeX ()
    "LaTex the curent file."
    (interactive)
    (save-buffer)
    (TeX-command-menu "LaTeX")
    ;(TeX-command "Texify" 'TeX-master-file)
    ;(TeX-command "Texify" 'TeX-active-buffer) is not working
    )
(defun do-DVIview ()
   "YAPview the curent file."
   (interactive)
   (save-buffer)
   (TeX-command-menu "View-Line")
   ;(TeX-command "View-Line" 'TeX-master-file)
   )
(defun do-PDFmode ()
   "Compile with pdflatex in PDF-mode."
   (interactive)
   (save-buffer)
   (TeX-command "PDFmode" 'TeX-master-file)
)
(defun do-TeX-And-View ()
   "Texify the curent file and view."
   (interactive)
   (save-buffer)
   (TeX-command "All Texify run-viewer" 'TeX-master-file)
)
(defun do-PDF-close ()
   "Close PDF-File inside Acrobad Reader."
   (interactive)
   (save-buffer)
   (TeX-command "Close PDF-File" 'TeX-master-file)
)
(defun do-Texify ()
   "Texify the curent file and view line."
   (interactive)
   (save-buffer)
   (TeX-command-menu "Texify")
   ;(TeX-command "Texify" 'TeX-master-file)
)
(defun do-PDF ()
   "Texify the current file and view line."
   (interactive)
   (save-buffer)
   (TeX-command "Texify pdf" 'TeX-master-file)
)
(defun do-texify2DVIPDFMX ()
   "Texify the current file and view line."
   (interactive)
   (save-buffer)
   (TeX-command "batch file TEX -> DVIPDFMX.EXE(extended DVIPDFM) -> PDF" 'TeX-master-file)
)




;;;; end of init.el
;;; ********************
;;;; some interesting things:
;;;; gnuserve:
;;; http://www.math.aau.dk/~dethlef/Tips/local/gnuserv-2.1p1.zip
;;;; other things:
;;; http://www.math.auc.dk/~dethlef/Tips/download.html
;;; http://www.zonix.de/div/el/emacs_tex.html
;;; http://www.dotemacs.de/
;;;; ispell:
;;; http://fmg-www.cs.ucla.edu/geoff/ispell.html
;;; http://www.kdstevens.com/~stevens/ispell-faq.html#get-ispell
;;;; Latest WIN32-LaTeX related binaries, e.g. ispell
;;; http://www.fsci.fuk.kindai.ac.jp/kakuto/win32-ptex/web2c75-e.html
;;; Have fun with xemacs + LaTeX!
